package be.iminds.ilabt.jfed.highlevel.tasks;

import be.iminds.ilabt.jfed.experiment.Experiment;
import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Server;
import be.iminds.ilabt.jfed.util.common.GeniUrn;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;
import java.util.Optional;
import java.util.Set;

public interface RecoverSliceTaskInteraction {
    void onCouldNotRetrieve(@Nullable Throwable exception);
    void onUnknownAuthoritiesDetected(@Nonnull String sliceName, @Nonnull List<GeniUrn> unknownAuthorities) throws InterruptedException;

    /**
     * @param sliceName
     * @return true if the user should be asked to manually select resources using requestAuthorities()
     * @throws InterruptedException
     */
    boolean onNoActiveResources(@Nonnull String sliceName) throws InterruptedException;
    @Nonnull Optional<Set<Server>> requestAuthorities() throws InterruptedException;
    void onCouldNotFindInfoWhenUserSelected(@Nonnull String sliceName) throws InterruptedException;
    void onCouldNotFindInfoWhenAutoSelected(@Nonnull String sliceName, @Nonnull Set<Server> allInvolvedAuthorities);
    void onFinalFailed(@Nonnull String sliceName, @Nullable String message, @Nullable Throwable exception);
    void onFinalSucces(@Nonnull Experiment experiment);
}
